document.addEventListener('DOMContentLoaded', () => {
   if (location.search != '?update') {
      browser.tabs.query({
         active: true,
         currentWindow: true
      }).then(t => {
         if (t[0]) {
            browser.tabs.update(t[0].id, {
               active: true,
               url: browser.runtime.getURL('list/list.html?update')
            });
         }
      }, () => {});
   } else {
      browser.storage.local.get('conf').then(r => {
         if (r.conf) {
            if (r['conf']['opt00'] && r['conf']['opt00'] == 1) {
               document.querySelector('html').setAttribute('dark', 1);
            }
            for (let rI in r.conf) {
               if (document.getElementById(rI)) {
                  document.getElementById(rI).checked = (r['conf'][rI] == 1) ? true : false;
               }
            }
            if (r['conf']['ignored'] && Object.keys(r['conf']['ignored']).length >= 1) {
               document.getElementById('ignored').value = Object.keys(r['conf']['ignored']).join("\n");
            } else {
               document.getElementById('ignored').value = '';
            }
         }
      });
   }
});
async function reading() {
   await browser.runtime.sendMessage(['ping']).then(x => {
      let statw = document.getElementById('stat');
      statw.value = x.join("\n");
      statw.scrollTop = statw.scrollHeight;
      if (!x.includes('Done!')) {
         setTimeout(reading, 700);
      } else {
         document.body.className = '';
      }
   }, () => {
      alert('localhost reading error');
      location.reload();
   });
}
document.getElementById('doact').addEventListener('click', () => {
   let newCFG = {};
   document.querySelectorAll('input[type=checkbox]').forEach(x => {
      newCFG[x.id] = x.checked ? '1' : '0';
   });
   newCFG['ignored'] = {};
   for (let ool of document.getElementById('ignored').value.split(/\r\n|\r|\n/)) {
      if (/^([a-z0-9]{1})([a-z0-9.-]{0,254})\.([a-z]{2,50})$/.test(ool)) {
         newCFG['ignored'][ool] = 1;
      }
   }
   browser.storage.local.set({
      'conf': newCFG
   }).then(x => {
      document.body.className = 'locked';
      document.getElementById('stat').value = '';
      browser.runtime.sendMessage(['reload']).then(() => {
         browser.runtime.sendMessage(['update']).then(() => {
            reading();
         }, () => {
            alert('localhost update error');
            location.reload();
         });
      }, () => {
         alert('localhost reload error');
         location.reload();
      });
   }, () => {
      alert('Config save error');
      location.reload();
   });
});